vRP = Proxy.getInterface("vRP")
vRPserver = Tunnel.getInterface("vRP","esk_dealership")
vRPds = Tunnel.getInterface("esk_dealership","esk_dealership")
vRPdsC = {}
Tunnel.bindInterface("esk_dealership",vRPdsC)
vRPSds = Tunnel.getInterface("esk_dealership","esk_dealership")


local inShowroom = false
local inTesting = false
local showroomID = nil
local testVehicle = nil
local cam = nil

CreateThread(function()


    while true do 
        local sleep = config.defaultWaitTime

        for k,v in pairs(config.dealerships) do 
            local dist = #(GetEntityCoords(PlayerPedId()) - v.coordsPed)
            if dist < 1.5 then
                sleep = 5
                ShowHelpNotification(config.openSHmsg)
                if IsControlJustPressed(0, 51) then
                    openCategories(k)
                end
            end
        end

        Wait(sleep)
    end
end)

RegisterNetEvent("esk:openshowroom")
AddEventHandler("esk:openshowroom",function()
    for k,v in pairs(config.dealerships) do 
        openCategories(k)
    end
end)

openCategories = function(id)
    SetEntityVisible(PlayerPedId(), false)
    SetEntityCoords(PlayerPedId(),config.dealerships[id].coordsVehicle)
    inShowroom = true
    showroomID = id
    inTestingTime = 0
    cam = CreateCam("DEFAULT_SCRIPTED_CAMERA", 1)

    if config.dealerships[id].type == "vehicles" then
        SetCamCoord(cam, config.dealerships[id].coordsCam[1], config.dealerships[id].coordsCam[2], config.dealerships[id].coordsCam[3])
        PointCamAtCoord(cam, config.dealerships[id].coordsVehicle[1]+1.0, config.dealerships[id].coordsVehicle[2]+1.0, config.dealerships[id].coordsVehicle[3])
        RenderScriptCams(1, 0, 0, 1, 1)
    elseif config.dealerships[id].type == "airplane" then 
        SetCamCoord(cam, config.dealerships[id].coordsCam[1], config.dealerships[id].coordsCam[2], config.dealerships[id].coordsCam[3])
        PointCamAtCoord(cam, config.dealerships[id].coordsVehicle[1], config.dealerships[id].coordsVehicle[2], config.dealerships[id].coordsVehicle[3])
        RenderScriptCams(1, 0, 0, 1, 1)
    elseif config.dealerships[id].type == "boats" then 
        SetCamCoord(cam, config.dealerships[id].coordsCam[1], config.dealerships[id].coordsCam[2], config.dealerships[id].coordsCam[3])
        PointCamAtCoord(cam, config.dealerships[id].coordsVehicle[1], config.dealerships[id].coordsVehicle[2], config.dealerships[id].coordsVehicle[3])
        RenderScriptCams(1, 0, 0, 1, 1)
    end

    SetNuiFocus(true, true)


    SendNUIMessage({
        action = "openShowroomCategories",
        sh_name = config.dealerships[id].name,
        sh_type = config.dealerships[id].type,
        veh_table = config.dealerships[id].vehicles,
    })
end

openShowroom = function(id, numeCategorie)
    SetEntityVisible(PlayerPedId(), false)
    SetEntityCoords(PlayerPedId(),config.dealerships[id].coordsVehicle)
    inShowroom = true
    showroomID = id
    inTestingTime = 0
    cam = CreateCam("DEFAULT_SCRIPTED_CAMERA", 1)

    if config.dealerships[id].type == "vehicles" then
        SetCamCoord(cam, config.dealerships[id].coordsCam[1], config.dealerships[id].coordsCam[2], config.dealerships[id].coordsCam[3])
        PointCamAtCoord(cam, config.dealerships[id].coordsVehicle[1]+1.0, config.dealerships[id].coordsVehicle[2]+1.0, config.dealerships[id].coordsVehicle[3])
        RenderScriptCams(1, 0, 0, 1, 1)
    elseif config.dealerships[id].type == "airplane" then 
        SetCamCoord(cam, config.dealerships[id].coordsCam[1], config.dealerships[id].coordsCam[2], config.dealerships[id].coordsCam[3])
        PointCamAtCoord(cam, config.dealerships[id].coordsVehicle[1], config.dealerships[id].coordsVehicle[2], config.dealerships[id].coordsVehicle[3])
        RenderScriptCams(1, 0, 0, 1, 1)
    elseif config.dealerships[id].type == "boats" then 
        SetCamCoord(cam, config.dealerships[id].coordsCam[1], config.dealerships[id].coordsCam[2], config.dealerships[id].coordsCam[3])
        PointCamAtCoord(cam, config.dealerships[id].coordsVehicle[1], config.dealerships[id].coordsVehicle[2], config.dealerships[id].coordsVehicle[3])
        RenderScriptCams(1, 0, 0, 1, 1)
    end

    SetNuiFocus(true, true)


    SendNUIMessage({
        action = "openShowroomJS",
        sh_name = config.dealerships[id].name,
        sh_type = config.dealerships[id].type,
        veh_table = config.dealerships[id].vehicles[numeCategorie],
    })
end

function ShowHelpNotification(text)
    SetTextComponentFormat("STRING")
    AddTextComponentString(text)
    DisplayHelpTextFromStringLabel(0, 0, 1, -1)
end

function getTuning()
    myveh = {}
    veh = GetVehiclePedIsUsing(GetPlayerPed(-1))
    SetVehicleModKit(veh,0)
    myveh.vehicle = veh
    myveh.plate = GetVehicleNumberPlateText(veh)
    myveh.model = GetDisplayNameFromVehicleModel(GetEntityModel(veh)):lower()
    myveh.modelhash = GetEntityModel(veh)
    r,g,b = GetVehicleCustomPrimaryColour(veh)
    r2,g2,b2 = GetVehicleCustomSecondaryColour(veh)
    myveh.color =  table.pack(r,g,b,r2,g2,b2)
    myveh.extracolor = table.pack(GetVehicleExtraColours(veh))
    nr,ng,nb = GetVehicleNeonLightsColour(veh)
    myveh.neoncolor = table.pack(nr,ng,nb)
    myveh.neon = {}
    myveh.smokecolor = table.pack(GetVehicleTyreSmokeColor(veh))
    myveh.plateindex = GetVehicleNumberPlateTextIndex(veh)
    myveh.mods = {}
    for i = 0, 48 do
        myveh.mods[i] = {mod = nil}
    end
    for i,t in pairs(myveh.mods) do
        if i == 22 or i == 18 then
            if IsToggleModOn(veh,i) then
                t.mod = 1
            else
                t.mod = 0
            end
        elseif i == 23 or i == 24 then
            t.mod = GetVehicleMod(veh,i)
            t.variation = GetVehicleModVariation(veh, i)
        else
            t.mod = GetVehicleMod(veh,i)
        end
    end
    if GetVehicleWindowTint(veh) == -1 or GetVehicleWindowTint(veh) == 0 then
        myveh.windowtint = false
    else
        myveh.windowtint = GetVehicleWindowTint(veh)
    end
    myveh.headlightscolor = GetVehicleHeadlightsColour(veh)
    myveh.wheeltype = GetVehicleWheelType(veh)
    myveh.bulletProofTyres = GetVehicleTyresCanBurst(veh)

    myveh.neon.left = IsVehicleNeonLightEnabled(veh,0)
    myveh.neon.right = IsVehicleNeonLightEnabled(veh,1)
    myveh.neon.front = IsVehicleNeonLightEnabled(veh,2)
    myveh.neon.back = IsVehicleNeonLightEnabled(veh,3)

    --Menu stuff
    local chassis,interior,bumper,fbumper,rbumper = false,false,false,false

    for i = 0,48 do
        if GetNumVehicleMods(veh,i) ~= nil and GetNumVehicleMods(veh,i) ~= false and GetNumVehicleMods(veh,i) > 0 then
            if i == 1 then
                bumper = true
                fbumper = true
            elseif i == 2 then
                bumper = true
                rbumper = true
            elseif (i >= 42 and i <= 46) or i == 5 then
                chassis = true
            elseif i >= 27 and i <= 37 then
                interior = true
            end
        end
    end
    return myveh
end

--NUI

RegisterNUICallback('closeShowroom', function(data, cb)
    DestroyCam(cam, false)
    SetCamActive(cam, false)
    RenderScriptCams(0, false, 100, false, false)
    SetNuiFocus(false, false)

    rablactuala = GetVehiclePedIsUsing(PlayerPedId())
    DeleteEntity(rablactuala)

    SetEntityCoords(PlayerPedId(),config.dealerships[showroomID].coordsPed[1]-1.0, config.dealerships[showroomID].coordsPed[2], config.dealerships[showroomID].coordsPed[3])

    inShowroom = false
    showroomID = nil
    SetEntityVisible(PlayerPedId(), true)
end)


RegisterNUICallback('changeVehicleColors', function(data, cb)
    if inShowroom then
        r, g, b = data.colours[1]:match("([^,]+),([^,]+),([^,]+)")
        rablactuala = GetVehiclePedIsUsing(PlayerPedId())
        if rablactuala ~= nil then
            SetVehicleCustomPrimaryColour(rablactuala, tonumber(r),tonumber(g),tonumber(b))
        end
    end
end)

RegisterNUICallback('schimbaCategoria', function(data, cb)
    openShowroom(showroomID, data.categorie)
end)

RegisterNUICallback('spawnTheVehicle', function(data, cb)
    for k,v in pairs (config.dealerships[showroomID].vehicles[tostring(data.numeC)]) do 
        
        if v.vehID == data.id then 
            model = v.spawncode
            RequestModel(model)
            local timpfake = 0
            while not HasModelLoaded(model) and timpfake < 500 do
                Wait(0)
                SetNuiFocus(false, false)
                timpfake = timpfake + 1
            end
            SetNuiFocus(true, true)
            rablactuala = GetVehiclePedIsUsing(PlayerPedId())
            if rablactuala == nil then
                local nveh = CreateVehicle(model, config.dealerships[showroomID].coordsVehicle[1], config.dealerships[showroomID].coordsVehicle[2], config.dealerships[showroomID].coordsVehicle[3], 120.0, false, false)
                SetPedIntoVehicle(PlayerPedId(),nveh,-1)
                SetVehicleEngineOn(nveh,false,false,0)
                SetVehicleDirtLevel(nveh,0.0)
                SetEntityHeading(nveh, config.dealerships[showroomID].headingVehicle)

                SetVehicleCustomPrimaryColour(nveh, 255,255,255)
                SetVehicleCustomSecondaryColour(nveh, 255,255,255)
            else
                DeleteEntity(rablactuala)
                local nveh = CreateVehicle(model, config.dealerships[showroomID].coordsVehicle[1], config.dealerships[showroomID].coordsVehicle[2], config.dealerships[showroomID].coordsVehicle[3], 120.0, false, false)
                SetPedIntoVehicle(PlayerPedId(),nveh,-1)
                SetVehicleEngineOn(nveh,false,true,true)
                SetVehicleDirtLevel(nveh,0.0)
                SetEntityHeading(nveh, config.dealerships[showroomID].headingVehicle)

                SetVehicleCustomPrimaryColour(nveh, 255,255,255)
                SetVehicleCustomSecondaryColour(nveh, 255,255,255)
            end

            SendNUIMessage({
                action = "updateVehicleSpecifications",
                speed = v.speed,
                acceleration = v.acceleration,
                brakes = v.brakes,
                seats = v.seats
            })
        end
    end
end)

function SecondsToClock(seconds,whatReturn)
    local seconds = tonumber(seconds)
  
    if seconds <= 0 then
      return "00:00:00";
    else
      hours = string.format("%02.f", math.floor(seconds/3600));
      mins = string.format("%02.f", math.floor(seconds/60 - (hours*60)));
      secs = string.format("%02.f", math.floor(seconds - hours*3600 - mins *60));
      if whatReturn == "hours" then
        return hours..":"..mins..":"..secs
      elseif whatReturn == "minutes" then
        return mins..":"..secs
      else
        return hours..":"..mins..":"..secs
      end
    end
end

RegisterNUICallback('spawnTheVehicleForTesting', function(data, cb)
    if inShowroom then
        for k,v in pairs (config.dealerships[showroomID].vehicles[tostring(data.numeC)]) do 
            if v.vehID == data.selectedVehicle then
                vRPSds.checkMoneyForTesting({v.price},function(haveMoney)

                    if haveMoney then

                        SendNUIMessage({action = "startTestingTheVehicle"})

                        model = v.spawncode
                        rablactuala = GetVehiclePedIsUsing(PlayerPedId())
                        DeleteEntity(rablactuala)

                        local nveh = CreateVehicle(model, config.dealerships[showroomID].testVehicleSpawn[1], config.dealerships[showroomID].testVehicleSpawn[2], config.dealerships[showroomID].testVehicleSpawn[3], config.dealerships[showroomID].testVehicleSpawnHeading, false, false)
                        SetPedIntoVehicle(PlayerPedId(),nveh,-1)
                        SetVehicleEngineOn(nveh,true,true,true)
                        SetVehicleDirtLevel(nveh,0.0)

                        testVehicle = nveh

                        if data.selectedColor == 0 then
                            SetVehicleCustomPrimaryColour(nveh, 255,255,255)
                        else
                            r, g, b = data.selectedColor[1]:match("([^,]+),([^,]+),([^,]+)")
                            rablactuala = GetVehiclePedIsUsing(PlayerPedId())
                            if rablactuala ~= nil then
                                SetVehicleCustomPrimaryColour(nveh, tonumber(r),tonumber(g),tonumber(b))
                            end
                        end

                        inShowroom = false
                        SetEntityVisible(PlayerPedId(), true)
                        DestroyCam(cam, false)
                        SetCamActive(cam, false)
                        RenderScriptCams(0, false, 100, false, false)
                        SetNuiFocus(false, false)

                        inTesting = true
                        inTestingTime = config.dealerships[showroomID].testVehicleTime

                        CreateThread(function()
                            while true do 
                                Wait(1000)
                                if inTesting then
                                    
                                    if not DoesEntityExist(testVehicle) then 
                                        DeleteEntity(testVehicle)
                                        inTestingTime = 0
                                    end

                                    if GetEntityHealth(PlayerPedId()) < 121 then 
                                        SetEntityHealth(PlayerPedId(),200)
                                        DeleteEntity(testVehicle)
                                        inTestingTime = 0
                                    end

                                    if inTestingTime == 0 then 

                                        DeleteEntity(GetVehiclePedIsUsing(PlayerPedId()))
                                        inTesting = false
                                        openShowroom(showroomID)
                                        break
                                    else
                                        SendNUIMessage({
                                            action = "timeRemaining",
                                            timeRemaining = SecondsToClock(inTestingTime,"minutes")
                                        })

                                        inTestingTime = inTestingTime - 1
                                        
                                    end
                                
                                end
                            end
                        end)
                    else
                        vRP.notify({"You don't have enough money for testing this vehcle."})
                    end
                end)
            end
        end
    end
end)


RegisterNUICallback('buyVehicle', function(data, cb)
    vRPSds.checkMoneyForBuyingVehicle({showroomID,data.selectedVehicle, data.numeC, getTuning()},function(haveMoney)
        if haveMoney then
            SendNUIMessage({action = "closeShowroom"})
        end
    end)
end)

RegisterNUICallback('openCategorii', function(data, cb)
    rablactuala = GetVehiclePedIsUsing(PlayerPedId())
    DeleteEntity(rablactuala)
    openCategories(showroomID)
end)